const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const MyPageSchema = new Schema({
  idapp: {
    type: String,
  },
  author_username: {
    type: String,
  },
  lang: {
    type: String,
  },
  title: {
    type: String,
  },
  icon: {
    type: String,
  },
  order: {
    type: Number,
    default: 1000,
  },
  path: {
    type: String,
  },
  keywords: {
    type: String,
  },
  description: {
    type: String,
  },
  heightimg: {
    type: Number,
  },
  onlyif_logged: {
    type: Boolean,
  },
  imgback: {
    type: String,
  },
  content: {
    type: String,
  },
  active: {
    type: Boolean,
  },
  inmenu: {
    type: Boolean,
  },
  submenu: {
    type: Boolean,
  },
  l_par: {
    type: Number,
  },
  l_child: {
    type: Number,
  },
  infooter: {
    type: Boolean,
  },
});

MyPageSchema.statics.getFieldsForSearch = function () {
  return [{ field: 'title', type: tools.FieldType.string },
    { field: 'keywords', type: tools.FieldType.string },
    { field: 'description', type: tools.FieldType.string },
    { field: 'content', type: tools.FieldType.string }]
};

MyPageSchema.statics.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

MyPageSchema.statics.findAllIdApp = async function (idapp) {
  const MyPage = this;

  const myfind = { idapp };

  return await MyPage.find(myfind, (err, arrrec) => {
    return arrrec
  });
};

const MyPage = mongoose.model('MyPage', MyPageSchema);

module.exports = { MyPage };
